diff a/installers/mac/pkg/build.gradle b/installers/mac/pkg/build.gradle
--- /dev/null
+++ b/installers/mac/pkg/build.gradle
@@ -0,0 +1,122 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+dependencies {
+    compile project(path: ':installers:mac:tar', configuration: 'buildTar')
+}
+
+// Copy task cannot be used here because Gradle does not preserve the symlink
+task retrieveArtifacts(type: Exec) {
+    // Set environment variable CORRETTO_ARTIFACTS_PATH to the path of "amazon-corretto-<version>.jdk" to be packaged
+    def artifactsPath = System.getenv("CORRETTO_ARTIFACTS_PATH")
+    workingDir buildRoot
+    if (artifactsPath == null) {
+        dependsOn project.configurations.compile
+        commandLine "tar", "xf", project.configurations.compile.singleFile
+    } else {
+        commandLine "cp", "-Rf", "${artifactsPath}", buildRoot
+    }
+}
+
+task copyResources(type: Copy) {
+    from "."
+    include 'resources/**'
+    into buildRoot
+}
+
+task inflatePkgTemplate {
+    dependsOn copyResources
+    doLast {
+        copy {
+            from('templates/distribution.xml.template') {
+                rename { file -> file.replace('.template', '') }
+                filter(org.apache.tools.ant.filters.ReplaceTokens, tokens: ["full": project.version.full, "major": project.version.major, "macos-arch": (correttoArch == "aarch64" ? "arm64" : "x86_64")])
+            }
+            into "${buildRoot}/resources"
+        }
+
+        copy {
+            from('templates/introduction.html.template') {
+                rename { file -> file.replace('.template', '') }
+                filter(org.apache.tools.ant.filters.ReplaceTokens, tokens: project.version)
+            }
+            into "${buildRoot}/resources"
+        }
+    }
+}
+
+task setupDirectories {
+    dependsOn retrieveArtifacts
+    doLast {
+        exec {
+            workingDir buildRoot
+            commandLine "mkdir", "-p", "pkgroot/"
+        }
+
+        exec {
+            workingDir buildRoot
+            commandLine "cp", "-Rf", "amazon-corretto-${project.version.major}.jdk", "pkgroot/"
+        }
+
+        exec {
+            workingDir buildRoot
+            commandLine "mkdir", "-p", "build/components"
+        }
+    }
+}
+
+task generateInstaller {
+    dependsOn retrieveArtifacts
+    dependsOn copyResources
+    dependsOn inflatePkgTemplate
+    dependsOn setupDirectories
+    outputs.dir distributionDir
+
+    doLast {
+        exec {
+            workingDir buildRoot
+            commandLine "pkgbuild",
+                "--root", "pkgroot",
+                "--identifier", "com.amazon.corretto.${project.version.major}",
+                "--version", project.version.full,
+                "--ownership", "recommended",
+                "--scripts", "resources",
+                "--install-location", "/Library/Java/JavaVirtualMachines/",
+                "build/components/amazon-corretto-${project.version.major}.jdk.pkg"
+        }
+
+        exec {
+            workingDir buildRoot
+            commandLine "productbuild",
+            "--distribution", "resources/distribution.xml",
+            "--resources", "resources",
+            "--package-path", "build/components",
+            "--version", project.version.full,
+            "${distributionDir}/amazon-corretto-${project.version.full}-macosx-${correttoArch}.pkg"
+        }
+    }
+}
+
+build.dependsOn generateInstaller
+
+artifacts {
+    archives file: generateInstaller.outputs.getFiles().getSingleFile(), builtBy: generateInstaller
+}
diff a/installers/mac/pkg/resources/preinstall b/installers/mac/pkg/resources/preinstall
--- /dev/null
+++ b/installers/mac/pkg/resources/preinstall
@@ -0,0 +1,9 @@
+#!/bin/bash
+JDK_INSTALL_PATH="/Library/Java/JavaVirtualMachines"
+MKDIR=`which mkdir`
+
+if [[ ! -d ${JDK_INSTALL_PATH} ]]; then
+	${MKDIR} -p ${JDK_INSTALL_PATH}
+fi
+
+exit 0
diff a/installers/mac/tar/build.gradle b/installers/mac/tar/build.gradle
--- /dev/null
+++ b/installers/mac/tar/build.gradle
@@ -0,0 +1,208 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+dependencies {
+    compile project(path: ':openjdksrc', configuration: 'archives')
+    compile project(path: ':prebuild', configuration: 'cacerts')
+}
+
+// Two configurations for tgz & Jtreg native library respectively.
+// Separate artifacts to simplify the artifacts fetching in :mac:pkg.
+configurations {
+    buildTar
+    testLib
+}
+// consts
+def imageDir= "$buildRoot/build/${project.jdkImageName}/images"
+def jdkResultingImage = "${imageDir}/jdk-bundle"
+def testResultingImage = "${imageDir}/test"
+def correttoMacDir = "amazon-corretto-${project.version.major}.jdk"
+
+// deps
+def depsMap = [:]
+project.configurations.compile.getFiles().each { depsMap[it.getName()] = it }
+
+/**
+ * Create a local copy of the source tree in our
+ * build root -- this is required since OpenJDK's
+ * build wants to occur inside the source tree,
+ * and we don't want to tamper with someone
+ * else's tree.
+ */
+task copySource(type: Exec) {
+    if (!file(buildRoot).exists()) {
+        file(buildRoot).mkdirs()
+    }
+    workingDir '/usr/bin'
+    commandLine 'rsync', '-am',
+            '--exclude=pre-build',
+            '--exclude=installers',
+            '--exclude=corretto-build',
+            "${project.rootDir}/", buildRoot
+}
+
+task configureBuild(type: Exec) {
+    dependsOn project.configurations.compile
+    dependsOn copySource
+    workingDir "$buildRoot"
+
+    // Platform specific flags
+    def command = ['bash', 'configure',
+            "--with-cacerts-file=${depsMap[caCerts]}"
+    ]
+    if (project.correttoArch == "aarch64") {
+        command += "--with-zlib=bundled"
+    }
+    // Common flags
+    command += project.correttoCommonFlags
+    commandLine command.flatten()
+}
+
+task executeBuild(type: Exec) {
+    dependsOn configureBuild
+    workingDir "$buildRoot"
+    commandLine 'make', 'images'
+}
+
+task executeTestBuild(type: Exec) {
+    dependsOn executeBuild
+    workingDir "$buildRoot"
+    commandLine 'make','test-image'
+}
+
+task prepareArtifacts {
+    dependsOn executeBuild
+    doLast {
+        if(file("${jdkResultingImage}/${correttoMacDir}").exists()) {
+            delete "${jdkResultingImage}/${correttoMacDir}"
+        }
+        // Rename bundle
+        exec {
+            workingDir jdkResultingImage
+            commandLine 'bash', '-c', "\"\"mv jdk-${version.major}*.jdk ${correttoMacDir}\"\""
+        }
+
+        // Replace Info.plist
+        def plistTokens = new Properties()
+        plistTokens["INFO"] = "Amazon Corretto ${project.version.full}-${versionOpt}".toString()
+        plistTokens["ID"] = "com.amazon.corretto.${project.version.major}".toString()
+        plistTokens["NAME"] = "Amazon Corretto ${project.version.major}".toString()
+        plistTokens["VERSION"] = "${project.version.major}.${project.version.minor}.${project.version.security}".toString()
+        plistTokens["BUILD_VERSION"] = "${project.version.full}".toString()
+        plistTokens["MACOSX_VERSION_MIN"] = (correttoArch == "x64" ? "10.12" : "11.0")
+        plistTokens["VENDOR"] = "Amazon.com Inc."
+
+        copy {
+            from("${rootDir}/make/data/bundle/JDK-Info.plist.template") {
+                rename { file -> 'Info.plist' }
+                filter(org.apache.tools.ant.filters.ReplaceTokens, beginToken: "@@", endToken: "@@", tokens: plistTokens)
+            }
+            into "${jdkResultingImage}/${correttoMacDir}/Contents"
+        }
+
+        // If property set, copy async profiler binaries to bundle
+        if (project.asyncProfilerBinariesPath != "") {
+            if (!file(project.asyncProfilerBinariesPath).isDirectory()) {
+                throw new GradleException("asyncProfilerBinariesPath is not a valid directory: ${project.asyncProfilerBinariesPath}")
+            }
+            copy {
+                from project.asyncProfilerBinariesPath
+                include 'bin/**', 'lib/**'
+                into "${jdkResultingImage}/${correttoMacDir}/Contents/Home"
+            }
+            copy {
+                from project.asyncProfilerLegal
+                into "${jdkResultingImage}/${correttoMacDir}/Contents/Home/legal"
+            }
+        }
+
+        // Filter files
+        if(file("${buildDir}/${correttoMacDir}").exists()) {
+            delete "${buildDir}/${correttoMacDir}"
+        }
+        copy {
+            from("${jdkResultingImage}/${correttoMacDir}") {
+                include "Contents/Home/bin/**"
+                include "Contents/Home/conf/**"
+                include "Contents/Home/include/**"
+                include "Contents/Home/jmods/**"
+                include "Contents/Home/legal/**"
+                include "Contents/Home/lib/**"
+                include "Contents/Home/man/man1/**"
+                include "Contents/Home/release"
+                include "Contents/Info.plist"
+                include "Contents/MacOS/**"
+                exclude "Contents/Home/**/*.diz"
+            }
+            from(buildRoot) {
+                include project.rootFiles
+                into "Contents/Home"
+            }
+            into "${buildDir}/${correttoMacDir}"
+        }
+        // Set the directory as bundle
+        exec {
+            commandLine "SetFile", "-a", "B", "${buildDir}/${correttoMacDir}"
+        }
+    }
+}
+
+task packaging(type: Exec) {
+    dependsOn prepareArtifacts
+    String tarDir = "${distributionDir}/${project.correttoJdkArchiveName}.tar.gz"
+    workingDir buildDir
+    commandLine "tar", "czf", tarDir, correttoMacDir
+    outputs.file tarDir
+}
+
+task packageDebugSymbols(type: Tar) {
+    dependsOn prepareArtifacts
+    description 'Package debug symbols'
+    archiveFileName = "${project.correttoDebugSymbolsArchiveName}.tar.gz"
+    compression Compression.GZIP
+    from("${jdkResultingImage}/${correttoMacDir}") {
+        include "Contents/Home/bin/*.diz"
+        include "Contents/Home/lib/*.diz"
+        include "Contents/Home/lib/server/*.diz"
+    }
+    into "${buildDir}/${correttoMacDir}"
+    into project.correttoDebugSymbolsArchiveName
+}
+
+task packageTestResults(type: Tar) {
+    dependsOn executeTestBuild
+    description 'Package test results'
+    archiveFileName = "${project.correttoTestImageArchiveName}.tar.gz"
+    compression Compression.GZIP
+    from(testResultingImage) {
+        include '**'
+    }
+    into project.correttoTestImageArchiveName
+}
+
+build.dependsOn packaging
+build.dependsOn packageDebugSymbols
+build.dependsOn packageTestResults
+
+artifacts {
+    buildTar file: packaging.outputs.getFiles().getSingleFile(), builtBy: packaging
+    testLib packageTestResults
+}
diff a/installers/windows/zip/build.gradle b/installers/windows/zip/build.gradle
--- /dev/null
+++ b/installers/windows/zip/build.gradle
@@ -0,0 +1,109 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+dependencies {
+    compile project(path: ':openjdksrc', configuration: 'archives')
+    compile project(path: ':prebuild', configuration: 'cacerts')
+}
+
+def imageDir = "$buildRoot/build/${project.jdkImageName}/images"
+def jdkResultingImage = "${imageDir}/jdk"
+def testResultingImage = "${imageDir}/test"
+
+// deps
+def depsMap = [:]
+project.configurations.compile.getFiles().each { depsMap[it.getName()] = it }
+
+task copySource(type: Copy) {
+    dependsOn project.configurations.compile
+    from tarTree(depsMap[sourceTar])
+    into buildRoot
+}
+
+
+task configureBuild(type: Exec) {
+    dependsOn copySource
+    workingDir buildRoot
+
+    // Platform specific flags
+    def command = ['bash', 'configure',
+           "--with-cacerts-file=${depsMap[caCerts]}",
+           "--with-boot-jdk=${project.getProperty('bootjdk_dir')}",
+           "--with-zlib=bundled"
+    ]
+    // Common flags
+    command += project.correttoCommonFlags
+    commandLine command.flatten()
+}
+
+task executeBuild(type: Exec) {
+    dependsOn configureBuild
+    workingDir buildRoot
+    commandLine 'make', 'images'
+    outputs.dir jdkResultingImage
+}
+
+task createTestImage(type: Exec) {
+    dependsOn executeBuild
+    workingDir "$buildRoot"
+    commandLine 'make','test-image'
+}
+
+task packageTestImage(type: Zip) {
+    dependsOn createTestImage
+    archiveFileName = "${project.correttoTestImageArchiveName}.zip"
+    from(testResultingImage) {
+        include '**'
+    }
+    into project.correttoTestImageArchiveName
+}
+
+task packageDebugSymbols(type: Zip) {
+    dependsOn packageTestImage
+    archiveFileName = "${project.correttoDebugSymbolsArchiveName}.zip"
+
+    from(jdkResultingImage) {
+        include 'bin/*.diz'
+        include 'lib/*.diz'
+        include 'lib/server/*.diz'
+        into project.correttoDebugSymbolsArchiveName
+    }
+}
+
+task packageBuildResults(type: Zip) {
+    dependsOn packageDebugSymbols
+    archiveFileName = "unsigned-jdk-image.zip"
+
+    from(jdkResultingImage) {
+        exclude 'demo'
+        exclude '**/*.diz'
+    }
+
+    from(buildRoot) {
+        include project.rootFiles
+    }
+}
+
+build.dependsOn packageBuildResults
+
+artifacts {
+    archives packageBuildResults
+}
diff a/settings.gradle b/settings.gradle
--- /dev/null
+++ b/settings.gradle
@@ -0,0 +1,23 @@
+rootProject.name = 'corretto-25'
+
+import org.apache.tools.ant.taskdefs.condition.Os
+
+def subProjects = [':openjdksrc', ':prebuild']
+
+if (Os.isFamily(Os.FAMILY_MAC)) {
+    subProjects += [':installers:mac:pkg',
+                    ':installers:mac:tar']
+} else if (Os.isFamily(Os.FAMILY_UNIX)) {
+    subProjects += [':installers:linux:universal:tar',
+                    ':installers:linux:universal:rpm',
+                    ':installers:linux:universal:deb',
+                    ':installers:linux:al2:spec',
+                    ':installers:linux:alpine:tar']
+} else if (Os.isFamily(Os.FAMILY_WINDOWS)) {
+    subProjects += [':installers:windows:zip']
+}
+
+include subProjects as String[]
+
+project(':openjdksrc').projectDir = file('source')
+project(':prebuild').projectDir = file('pre-build')
diff a/src/hotspot/cpu/aarch64/assembler_aarch64.hpp b/src/hotspot/cpu/aarch64/assembler_aarch64.hpp
--- a/src/hotspot/cpu/aarch64/assembler_aarch64.hpp
+++ b/src/hotspot/cpu/aarch64/assembler_aarch64.hpp
@@ -1134,10 +1134,14 @@
 
   void isb() {
     system(0b00, 0b011, 0b00011, SY, 0b110);
   }
 
+  void sb() {
+    system(0b00, 0b011, 0b00011, 0b0000, 0b111);
+  }
+
   void sys(int op1, int CRn, int CRm, int op2,
            Register rt = as_Register(0b11111)) {
     system(0b01, op1, CRn, CRm, op2, rt);
   }
 
diff a/src/hotspot/cpu/aarch64/globals_aarch64.hpp b/src/hotspot/cpu/aarch64/globals_aarch64.hpp
--- a/src/hotspot/cpu/aarch64/globals_aarch64.hpp
+++ b/src/hotspot/cpu/aarch64/globals_aarch64.hpp
@@ -115,11 +115,12 @@
           "Value -1 means off.")                                        \
           range(-1, 4096)                                               \
   product(ccstr, OnSpinWaitInst, "yield", DIAGNOSTIC,                   \
           "The instruction to use to implement "                        \
           "java.lang.Thread.onSpinWait()."                              \
-          "Options: none, nop, isb, yield.")                            \
+          "Valid values are: none, nop, isb, yield, sb.")               \
+          constraint(OnSpinWaitInstNameConstraintFunc, AtParse)         \
   product(uint, OnSpinWaitInstCount, 1, DIAGNOSTIC,                     \
           "The number of OnSpinWaitInst instructions to generate."      \
           "It cannot be used with OnSpinWaitInst=none.")                \
           range(1, 99)                                                  \
   product(ccstr, UseBranchProtection, "none",                           \
diff a/src/hotspot/cpu/aarch64/macroAssembler_aarch64.cpp b/src/hotspot/cpu/aarch64/macroAssembler_aarch64.cpp
--- a/src/hotspot/cpu/aarch64/macroAssembler_aarch64.cpp
+++ b/src/hotspot/cpu/aarch64/macroAssembler_aarch64.cpp
@@ -6798,10 +6798,11 @@
   }
 }
 #endif
 
 void MacroAssembler::spin_wait() {
+  block_comment("spin_wait {");
   for (int i = 0; i < VM_Version::spin_wait_desc().inst_count(); ++i) {
     switch (VM_Version::spin_wait_desc().inst()) {
       case SpinWait::NOP:
         nop();
         break;
@@ -6809,14 +6810,19 @@
         isb();
         break;
       case SpinWait::YIELD:
         yield();
         break;
+      case SpinWait::SB:
+        assert(VM_Version::supports_sb(), "current CPU does not support SB instruction");
+        sb();
+        break;
       default:
         ShouldNotReachHere();
     }
   }
+  block_comment("}");
 }
 
 // Stack frame creation/removal
 
 void MacroAssembler::enter(bool strip_ret_addr) {
diff a/src/hotspot/cpu/aarch64/spin_wait_aarch64.cpp b/src/hotspot/cpu/aarch64/spin_wait_aarch64.cpp
--- /dev/null
+++ b/src/hotspot/cpu/aarch64/spin_wait_aarch64.cpp
@@ -0,0 +1,52 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+#include "spin_wait_aarch64.hpp"
+#include "utilities/debug.hpp"
+
+#include <string.h>
+
+bool SpinWait::supports(const char *name) {
+  return name != nullptr &&
+         (strcmp(name, "nop")   == 0 ||
+          strcmp(name, "isb")   == 0 ||
+          strcmp(name, "yield") == 0 ||
+          strcmp(name, "sb")    == 0 ||
+          strcmp(name, "none")  == 0);
+}
+
+SpinWait::Inst SpinWait::from_name(const char* name) {
+  assert(supports(name), "checked by OnSpinWaitInstNameConstraintFunc");
+
+  if (strcmp(name, "nop") == 0) {
+    return SpinWait::NOP;
+  } else if (strcmp(name, "isb") == 0) {
+    return SpinWait::ISB;
+  } else if (strcmp(name, "yield") == 0) {
+    return SpinWait::YIELD;
+  } else if (strcmp(name, "sb") == 0) {
+    return SpinWait::SB;
+  }
+
+  return SpinWait::NONE;
+}
diff a/src/hotspot/cpu/aarch64/spin_wait_aarch64.hpp b/src/hotspot/cpu/aarch64/spin_wait_aarch64.hpp
--- a/src/hotspot/cpu/aarch64/spin_wait_aarch64.hpp
+++ b/src/hotspot/cpu/aarch64/spin_wait_aarch64.hpp
@@ -17,11 +17,10 @@
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
  *
  * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
  * or visit www.oracle.com if you need additional information or have any
  * questions.
- *
  */
 
 #ifndef CPU_AARCH64_SPIN_WAIT_AARCH64_HPP
 #define CPU_AARCH64_SPIN_WAIT_AARCH64_HPP
 
@@ -29,20 +28,26 @@
 public:
   enum Inst {
     NONE = -1,
     NOP,
     ISB,
-    YIELD
+    YIELD,
+    SB
   };
 
 private:
   Inst _inst;
   int _count;
 
+  Inst from_name(const char *name);
+
 public:
-  SpinWait(Inst inst = NONE, int count = 0) : _inst(inst), _count(count) {}
+  SpinWait(Inst inst = NONE, int count = 0) : _inst(inst), _count(inst == NONE ? 0 : count) {}
+  SpinWait(const char *name, int count) : SpinWait(from_name(name), count) {}
 
   Inst inst() const { return _inst; }
   int inst_count() const { return _count; }
+
+  static bool supports(const char *name);
 };
 
 #endif // CPU_AARCH64_SPIN_WAIT_AARCH64_HPP
diff a/src/hotspot/cpu/aarch64/vm_version_aarch64.cpp b/src/hotspot/cpu/aarch64/vm_version_aarch64.cpp
--- a/src/hotspot/cpu/aarch64/vm_version_aarch64.cpp
+++ b/src/hotspot/cpu/aarch64/vm_version_aarch64.cpp
@@ -49,25 +49,16 @@
 uintptr_t VM_Version::_pac_mask;
 
 SpinWait VM_Version::_spin_wait;
 
 static SpinWait get_spin_wait_desc() {
-  if (strcmp(OnSpinWaitInst, "nop") == 0) {
-    return SpinWait(SpinWait::NOP, OnSpinWaitInstCount);
-  } else if (strcmp(OnSpinWaitInst, "isb") == 0) {
-    return SpinWait(SpinWait::ISB, OnSpinWaitInstCount);
-  } else if (strcmp(OnSpinWaitInst, "yield") == 0) {
-    return SpinWait(SpinWait::YIELD, OnSpinWaitInstCount);
-  } else if (strcmp(OnSpinWaitInst, "none") != 0) {
-    vm_exit_during_initialization("The options for OnSpinWaitInst are nop, isb, yield, and none", OnSpinWaitInst);
+  SpinWait spin_wait(OnSpinWaitInst, OnSpinWaitInstCount);
+  if (spin_wait.inst() == SpinWait::SB && !VM_Version::supports_sb()) {
+    vm_exit_during_initialization("OnSpinWaitInst is SB but current CPU does not support SB instruction");
   }
 
-  if (!FLAG_IS_DEFAULT(OnSpinWaitInstCount) && OnSpinWaitInstCount > 0) {
-    vm_exit_during_initialization("OnSpinWaitInstCount cannot be used for OnSpinWaitInst 'none'");
-  }
-
-  return SpinWait{};
+  return spin_wait;
 }
 
 void VM_Version::initialize() {
   _supports_atomic_getset4 = true;
   _supports_atomic_getadd4 = true;
@@ -230,11 +221,15 @@
     if (FLAG_IS_DEFAULT(UseSIMDForMemoryOps)) {
       FLAG_SET_DEFAULT(UseSIMDForMemoryOps, true);
     }
 
     if (FLAG_IS_DEFAULT(OnSpinWaitInst)) {
-      FLAG_SET_DEFAULT(OnSpinWaitInst, "isb");
+      if (model_is(0xd4f) && VM_Version::supports_sb()) {
+        FLAG_SET_DEFAULT(OnSpinWaitInst, "sb");
+      } else {
+        FLAG_SET_DEFAULT(OnSpinWaitInst, "isb");
+      }
     }
 
     if (FLAG_IS_DEFAULT(OnSpinWaitInstCount)) {
       FLAG_SET_DEFAULT(OnSpinWaitInstCount, 1);
     }
diff a/src/hotspot/cpu/aarch64/vm_version_aarch64.hpp b/src/hotspot/cpu/aarch64/vm_version_aarch64.hpp
--- a/src/hotspot/cpu/aarch64/vm_version_aarch64.hpp
+++ b/src/hotspot/cpu/aarch64/vm_version_aarch64.hpp
@@ -129,10 +129,11 @@
     decl(ASIMDHP,       asimdhp,       10)    \
     decl(DCPOP,         dcpop,         16)    \
     decl(SHA3,          sha3,          17)    \
     decl(SHA512,        sha512,        21)    \
     decl(SVE,           sve,           22)    \
+    decl(SB,            sb,            29)    \
     decl(PACA,          paca,          30)    \
     /* flags above must follow Linux HWCAP */ \
     decl(SVEBITPERM,    svebitperm,    27)    \
     decl(SVE2,          sve2,          28)    \
     decl(A53MAC,        a53mac,        31)
diff a/src/hotspot/os_cpu/bsd_aarch64/os_bsd_aarch64.cpp b/src/hotspot/os_cpu/bsd_aarch64/os_bsd_aarch64.cpp
--- a/src/hotspot/os_cpu/bsd_aarch64/os_bsd_aarch64.cpp
+++ b/src/hotspot/os_cpu/bsd_aarch64/os_bsd_aarch64.cpp
@@ -47,12 +47,14 @@
 #include "runtime/osThread.hpp"
 #include "runtime/safepointMechanism.hpp"
 #include "runtime/sharedRuntime.hpp"
 #include "runtime/stubRoutines.hpp"
 #include "runtime/timer.hpp"
+#include "runtime/vm_version.hpp"
 #include "signals_posix.hpp"
 #include "utilities/align.hpp"
+#include "utilities/debug.hpp"
 #include "utilities/events.hpp"
 #include "utilities/vmError.hpp"
 
 // put OS-includes here
 # include <sys/types.h>
@@ -504,44 +506,36 @@
 static inline void atomic_copy64(const volatile void *src, volatile void *dst) {
   *(jlong *) dst = *(const jlong *) src;
 }
 
 extern "C" {
-  // needs local assembler label '1:' to avoid trouble when using linktime optimization
   int SpinPause() {
     // We don't use StubRoutines::aarch64::spin_wait stub in order to
     // avoid a costly call to os::current_thread_enable_wx() on MacOS.
     // We should return 1 if SpinPause is implemented, and since there
-    // will be a sequence of 11 instructions for NONE and YIELD and 12
-    // instructions for NOP and ISB, SpinPause will always return 1.
-    uint64_t br_dst;
-    const int instructions_per_case = 2;
-    int64_t off = VM_Version::spin_wait_desc().inst() * instructions_per_case * Assembler::instruction_size;
-
-    assert(VM_Version::spin_wait_desc().inst() >= SpinWait::NONE &&
-           VM_Version::spin_wait_desc().inst() <= SpinWait::YIELD, "must be");
-    assert(-1 == SpinWait::NONE,  "must be");
-    assert( 0 == SpinWait::NOP,   "must be");
-    assert( 1 == SpinWait::ISB,   "must be");
-    assert( 2 == SpinWait::YIELD, "must be");
-
-    asm volatile(
-        "  adr  %[d], 20          \n" // 20 == PC here + 5 instructions => address
-                                      // to entry for case SpinWait::NOP
-        "  add  %[d], %[d], %[o]  \n"
-        "  br   %[d]              \n"
-        "  b    1f                \n" // case SpinWait::NONE  (-1)
-        "  nop                    \n" // padding
-        "  nop                    \n" // case SpinWait::NOP   ( 0)
-        "  b    1f                \n"
-        "  isb                    \n" // case SpinWait::ISB   ( 1)
-        "  b    1f                \n"
-        "  yield                  \n" // case SpinWait::YIELD ( 2)
-        "1:        \n"
-        : [d]"=&r"(br_dst)
-        : [o]"r"(off)
-        : "memory");
+    // will be always a sequence of instructions, SpinPause will always return 1.
+    switch (VM_Version::spin_wait_desc().inst()) {
+    case SpinWait::NONE:
+      break;
+    case SpinWait::NOP:
+      asm volatile("nop" : : : "memory");
+      break;
+    case SpinWait::ISB:
+      asm volatile("isb" : : : "memory");
+      break;
+    case SpinWait::YIELD:
+      asm volatile("yield" : : : "memory");
+      break;
+    case SpinWait::SB:
+      assert(VM_Version::supports_sb(), "current CPU does not support SB instruction");
+      asm volatile(".inst 0xd50330ff" : : : "memory");
+      break;
+#ifdef ASSERT
+    default:
+      ShouldNotReachHere();
+#endif
+    }
     return 1;
   }
 
   void _Copy_conjoint_jshorts_atomic(const jshort* from, jshort* to, size_t count) {
     if (from > to) {
diff a/src/hotspot/os_cpu/bsd_aarch64/vm_version_bsd_aarch64.cpp b/src/hotspot/os_cpu/bsd_aarch64/vm_version_bsd_aarch64.cpp
--- a/src/hotspot/os_cpu/bsd_aarch64/vm_version_bsd_aarch64.cpp
+++ b/src/hotspot/os_cpu/bsd_aarch64/vm_version_bsd_aarch64.cpp
@@ -90,10 +90,13 @@
   }
   if (cpu_has("hw.optional.arm.FEAT_SHA3") ||
       cpu_has("hw.optional.armv8_2_sha3")) {
     _features |= CPU_SHA3;
   }
+  if (cpu_has("hw.optional.arm.FEAT_SB")) {
+    _features |= CPU_SB;
+  }
 
   int cache_line_size;
   int hw_conf_cache_line[] = { CTL_HW, HW_CACHELINE };
   sysctllen = sizeof(cache_line_size);
   if (sysctl(hw_conf_cache_line, 2, &cache_line_size, &sysctllen, nullptr, 0)) {
diff a/src/hotspot/os_cpu/linux_aarch64/vm_version_linux_aarch64.cpp b/src/hotspot/os_cpu/linux_aarch64/vm_version_linux_aarch64.cpp
--- a/src/hotspot/os_cpu/linux_aarch64/vm_version_linux_aarch64.cpp
+++ b/src/hotspot/os_cpu/linux_aarch64/vm_version_linux_aarch64.cpp
@@ -69,10 +69,14 @@
 
 #ifndef HWCAP_SVE
 #define HWCAP_SVE (1 << 22)
 #endif
 
+#ifndef HWCAP_SB
+#define HWCAP_SB (1 << 29)
+#endif
+
 #ifndef HWCAP_PACA
 #define HWCAP_PACA (1 << 30)
 #endif
 
 #ifndef HWCAP_FPHP
@@ -141,10 +145,11 @@
       HWCAP_ATOMICS |
       HWCAP_DCPOP   |
       HWCAP_SHA3    |
       HWCAP_SHA512  |
       HWCAP_SVE     |
+      HWCAP_SB      |
       HWCAP_PACA    |
       HWCAP_FPHP    |
       HWCAP_ASIMDHP);
 
   if (auxv2 & HWCAP2_SVE2) _features |= CPU_SVE2;
